commit d5340fea7efcf9995b7391a17b9781462556e661
Author: Leonid Krivoshein <klark@altlinux.org>
Date:   Tue Sep 28 00:14:28 2021 +0300

    core+waitdev: use common way for hooks call instead internal use_hooks()
    
    See also:
    https://lists.altlinux.org/pipermail/make-initrd/2021-September/000685.html

diff --git a/bootchain-core/data/etc/rc.d/init.d/bootchain b/bootchain-core/data/etc/rc.d/init.d/bootchain
index 7bdb1cf..1538339 100755
--- a/bootchain-core/data/etc/rc.d/init.d/bootchain
+++ b/bootchain-core/data/etc/rc.d/init.d/bootchain
@@ -17,24 +17,9 @@ NAME=bootchained
 PIDFILE="/var/run/$NAME.pid"
 ARGS="--lockfile $LOCKFILE --pidfile $PIDFILE --name $NAME --displayname $NAME"
 
-use_hooks()
-{
-	local hook hdir="$1"
-
-	if [ -d "$hdir" ]; then
-		# shellcheck disable=SC2012
-		for hook in $(ls -1 -- "$hdir"/* |sort) _; do
-			[ -s "$hook" ] ||
-				continue
-			. "$hook"
-		done
-	fi
-}
-
 start() {
 	RETVAL=0
 	if [ "${ROOT-}" = bootchain ] || [ "${ROOT-}" = pipeline ]; then
-		use_hooks /lib/bootchain-prepare.d
 		start_daemon --background $ARGS "$NAME"
 		RETVAL=$?
 	fi
diff --git a/bootchain-waitdev/data/lib/bootchain-prepare.d/300-waitdev b/bootchain-waitdev/data/lib/initrd/pre/bootchain-core/300-waitdev
old mode 100644
new mode 100755
similarity index 71%
rename from bootchain-waitdev/data/lib/bootchain-prepare.d/300-waitdev
rename to bootchain-waitdev/data/lib/initrd/pre/bootchain-core/300-waitdev
index f7315a3..5e0f040
--- a/bootchain-waitdev/data/lib/bootchain-prepare.d/300-waitdev
+++ b/bootchain-waitdev/data/lib/initrd/pre/bootchain-core/300-waitdev
@@ -1,10 +1,13 @@
 #!/bin/bash -efu
 
+. /.initrd/initenv
+
 dir=/.initrd/bootchain/waitdev
 mkdir -p -- "$dir"
 
 [ -z "${WAITDEV_TIMEOUT-}" ] ||
-	printf '%s\n' "$WAITDEV_TIMEOUT" >"$dir/TIMECNT"
+	printf '%s\n' "$WAITDEV_TIMEOUT" >"$dir"/TIMECNT
+
 i=0
 while [ "$i" -lt "${WAITDEV:-0}" ]; do
 	touch "$dir/$i"
